import { HttpClient } from '@angular/common/http';
import { ConfigService } from '@yukawa/chain-base-angular-client';
import { EditResult, HostStoreInfo, Info, QueryResult } from '@yukawa/chain-base-angular-domain';
import { Group, GroupFilter, Org, OrgFilter, Setting, SettingFilter, Tag, TagFilter, User, UserFilter } from './chain-main-angular-domain';
import { Account, RoleInfo } from '@yukawa/chain-security-angular-core';
import { Observable } from 'rxjs';
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.GroupsAspectRest <br/>
*/
export declare class GroupsService {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    deleteGroup(groupName: string): Observable<EditResult>;
    editGroup(group: Group): Observable<EditResult>;
    findGroups(pageSize?: number | null, firstResult?: number | null): Observable<Group[]>;
    insertGroup(group: Group): Observable<EditResult>;
    loadGroup(groupName: string): Observable<Group>;
    queryGroups(arg0: GroupFilter): Observable<QueryResult<Group>>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.MainModuleRest <br/>
*/
export declare class MainModuleRest {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.OrgAspectRestBase <br/>
*/
export declare class OrgServiceBase<V extends Org, F extends OrgFilter> {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    createOrg(arg0: V): Observable<EditResult>;
    deleteOrg(orgId: string): Observable<EditResult>;
    loadOrg(orgId: string): Observable<V>;
    queryOrgs(filter: F): Observable<QueryResult<V>>;
    updateOrg(arg0: V): Observable<EditResult>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.RolesAspectRest <br/>
*/
export declare class RolesService {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    findRoles(filter: RoleInfo): Observable<Info[]>;
    getAllRoles(): Observable<RoleInfo[]>;
    loadRole(roleName: string): Observable<RoleInfo>;
    queryRoles(filter: RoleInfo): Observable<QueryResult<RoleInfo>>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.SettingsAspectRest <br/>
*/
export declare class SettingsService {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    deleteSetting(module: string, shortName: string): Observable<EditResult>;
    editSetting(setting: Setting): Observable<EditResult>;
    /**
    *	find settings
    */
    findSettings(module?: string, shortName?: string, keyword?: string, pageSize?: number | null, firstResult?: number | null): Observable<Setting[]>;
    getMeta(): Observable<HostStoreInfo[]>;
    loadMapping(): Observable<{
        [key: string]: Object;
    }>;
    loadSetting(module: string, shortName: string): Observable<Setting>;
    ping(input?: Date): Observable<Date>;
    querySettings(filter: SettingFilter): Observable<QueryResult<Setting>>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.TagAspectRest <br/>
*/
export declare class TagService {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    ping(arg0?: Date): Observable<Date>;
    queryTags(arg0: TagFilter): Observable<QueryResult<Tag>>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.UserAspectRestBase <br/>
*/
export declare class UserServiceBase<V extends User, F extends UserFilter> {
    configService: ConfigService;
    httpService: HttpClient;
    constructor(httpService: HttpClient, configService: ConfigService);
    createUser(user: V): Observable<EditResult>;
    deleteUser(username: string): Observable<EditResult>;
    loadUser(username: string): Observable<V>;
    queryUsers(filter: F): Observable<QueryResult<V>>;
    /**
    *	synchronize user roles to security-service
    */
    synchronizeRoles(filter: F): Observable<Account[]>;
    updateUser(user: V): Observable<EditResult>;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.modules.main.rest.UsersAspectRest <br/>
*/
export declare class UsersService extends UserServiceBase<User, UserFilter> {
    configService: ConfigService;
    constructor(httpService: HttpClient, configService: ConfigService);
}
